using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Win32;
using System.Data;
using System.IO;
using System.IO.IsolatedStorage;
using System.Security.Permissions;
using System.Security;

namespace ClassLibrary1
{
    public class Class1
    {

        public String assertDeclarative()
        {
            RegistryPermission perm = new RegistryPermission(PermissionState.Unrestricted);
            perm.Assert();
            return getRegDeclarative();
        }

        [RegistryPermission(SecurityAction.Demand, Unrestricted=true)]
        public String getRegDeclarative()
        {
            try
            {
                RegistryKey rkey = Registry.LocalMachine;
                RegistryKey rkey1 = rkey.OpenSubKey("HARDWARE\\DESCRIPTION\\System\\CentralProcessor\\0");
                Console.WriteLine(rkey.GetValue("ProcessorNameString"));
                return (String)rkey.GetValue("ProcessorNameString", "foo");
            }
            catch (SecurityException se)
            {
                Console.WriteLine("SE caught! " + se.ToString());
                return "SE caught while declarative regging! " + se.ToString();
            }
        }

        public String assertImperative()
        {
            RegistryPermission perm = new RegistryPermission(PermissionState.Unrestricted);
            perm.Assert();
            return getRegImperative();
        }

        public String getRegImperative()
        {
            RegistryPermission perm = new RegistryPermission(PermissionState.Unrestricted);
            try {
                perm.Demand();
                RegistryKey rkey = Registry.LocalMachine;
                RegistryKey rkey1 = rkey.OpenSubKey("HARDWARE\\DESCRIPTION\\System\\CentralProcessor\\0");
                Console.WriteLine(rkey.GetValue("ProcessorNameString"));
                return (String) rkey.GetValue("ProcessorNameString", "foo");
            } catch (SecurityException se){
                Console.WriteLine("Can't read registry! "+se);
                return "SE caught while imperative regging! " + se.ToString();
            }
        }

        [IsolatedStorageFilePermission(SecurityAction.Demand, Unrestricted=true)]
        public bool iStorageDeclarative()
        {
            IsolatedStorageFile store = IsolatedStorageFile.GetUserStoreForDomain();
            IsolatedStorageFileStream stream = new IsolatedStorageFileStream("data.xml", FileMode.Create, store);
            StreamWriter sw = new StreamWriter(stream);
            sw.Write("Zapisane!");
            sw.Close();
            stream = new IsolatedStorageFileStream("data.xml", FileMode.Open, store);
            StreamReader sr = new StreamReader(stream);
            Console.WriteLine(sr.Read());
            sr.Close();
            stream.Dispose();
            store.Dispose();
            return true;
        }

        public bool iStorageImperative()
        {
            IsolatedStoragePermission perm = new IsolatedStorageFilePermission(PermissionState.Unrestricted);
            try {
                perm.Demand();
                IsolatedStorageFile store = IsolatedStorageFile.GetUserStoreForDomain();
                IsolatedStorageFileStream stream = new IsolatedStorageFileStream("data.xml", FileMode.Create, store);
                StreamWriter sw = new StreamWriter(stream);
                sw.Write("Zapisane!");
                sw.Close();
                stream = new IsolatedStorageFileStream("data.xml", FileMode.Open, store);
                StreamReader sr = new StreamReader(stream);
                Console.WriteLine(sr.Read());
                sr.Close();
                stream.Dispose();
                store.Dispose();
                return true;
            } catch (SecurityException se) {
                Console.WriteLine("Can't perform isolated storage operations");
                return false;
            }
        }

        [FileIOPermission(SecurityAction.Demand, Unrestricted=true)]
        public bool fOperationDeclarative()
        {
            FileStream file = new FileStream("C:\\test.txt", FileMode.OpenOrCreate, FileAccess.Write);
            StreamWriter sw = new StreamWriter(file);
            sw.Write("Hello file system world!");
            sw.Close();
            file = new FileStream("C:\\test.txt", FileMode.Open, FileAccess.Read);
            StreamReader sr = new StreamReader(file);
            Console.WriteLine(sr.Read());
            sr.Close();
            return true;
        }

        public bool fOperationImperative()
        {
            FileStream file;
            FileIOPermission perm;
            perm = new FileIOPermission(FileIOPermissionAccess.Write, "C:\\test.txt");
            try
            {
                perm.Demand();
                file = new FileStream("C:\\test.txt", FileMode.OpenOrCreate, FileAccess.Write);
                StreamWriter sw = new StreamWriter(file);
                sw.Write("Hello file system world!");
                sw.Close();
            } catch (SecurityException se ) {
                Console.WriteLine("Can't acquire permission to write file");
                return false;
            }
            perm = new FileIOPermission(FileIOPermissionAccess.Read, "C:\\test.txt");
            try
            {
                perm.Demand();
                file = new FileStream("C:\\test.txt", FileMode.Open, FileAccess.Read);
                StreamReader sr = new StreamReader(file);
                Console.WriteLine(sr.Read());
                sr.Close();
            } catch (SecurityException se ) {
                Console.WriteLine("Can't acquire permission to read file");
                return false;
            }
            return true;
        }
    }
}
